﻿Namespace CustomObject
    Public Class CustomColumnData
        Private _data As String

        Public Property Data() As String
            Get
                Return _data
            End Get
            Set(ByVal value As String)
                _data = value
            End Set
        End Property
    End Class

    Public Class CustomDataRow
        Public Property ColumnData() As CustomColumnData()
            Get
                Return _columnData
            End Get
            Set(value As CustomColumnData())
                _columnData = value
            End Set
        End Property
        Private _columnData As CustomColumnData()

        Public Sub New(columnsCount As Integer)
            ColumnData = New CustomColumnData(columnsCount - 1) {}
        End Sub
    End Class

    Public Class CustomColumnInfo
        Public Property Name() As String
            Get
                Return _name
            End Get
            Set(value As String)
                _name = value
            End Set
        End Property
        Private _name As String

        Public Property DataTypeOfString() As String
            Get
                Return _dataTypeOfString
            End Get
            Set(value As String)
                _dataTypeOfString = value
            End Set
        End Property
        Private _dataTypeOfString As String
    End Class

    Public Class CustomDataTable
        Public Property Name() As String
            Get
                Return _name
            End Get
            Set(value As String)
                _name = value
            End Set
        End Property
        Private _name As String

        Public Property Columns() As CustomColumnInfo()
            Get
                Return _columns
            End Get
            Set(value As CustomColumnInfo())
                _columns = value
            End Set
        End Property
        Private _columns As CustomColumnInfo()

        Public Property Rows() As CustomDataRow()
            Get
                Return _rows
            End Get
            Set(value As CustomDataRow())
                _rows = value
            End Set
        End Property
        Private _rows As CustomDataRow()

        Public Sub New(columnsCount As Integer, rowsCount As Integer)
            Columns = New CustomColumnInfo(columnsCount - 1) {}
            Rows = New CustomDataRow(rowsCount - 1) {}
        End Sub
    End Class
End Namespace